<template>
  <div>
    <v-dialog v-model="mostrarAlertaBandera" persistent max-width="600">
      <v-card>
        <div class="btnCerrarModal" @click="mostrarAlerta(false)">
          <div>X</div>
        </div>
        <v-card-title class="headline">
          <div class="titModal">Alerta</div>
        </v-card-title>
        <div class="contModal tCenter">
          <div v-if="bandera == 0">
            <strong>No se obtuvo infiormación </strong>
          </div>
          <div v-if="bandera == 1">
            <strong>No ha seleccionado ceco o negocio</strong>
          </div>
          <div v-if="bandera == 2">
            <strong>No ha seleccionado ceco o negocio</strong>
          </div>
          <div v-if="bandera == 3">
            <strong>No ha seleccionado fecha inicio o fecha fin</strong>
          </div>
        </div>
      </v-card>
    </v-dialog>

    <div class="titSec">Búsqueda de Documento</div>
    <v-card style="background-color: #fafafa"> </v-card>
    <v-card>
      <div class="gris">
        <br /><br /><br />
        <v-row>
          <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1" />
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <MultipleCheckboxNegocioComponent
              :callbackChangeCheckBox="callbackChangeCheckBox"
            />
          </v-col>

          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <ListaCecoComponente
              v-model="value"
              :disabled="disabled"
              :callback="callbackCecoSeleccionado"
              :borrarDatos="borradoPorNivel"
              ref="listaCecoComponente"
            />
          </v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <div class="subtitle-2"><b>Fecha inicio </b></div>
            <v-menu
              ref="menuI"
              v-model="menuI"
              :close-on-content-click="false"
              :nudge-right="40"
              transition="scale-transition"
              offset-y
              :cache-items="false"
              max-width="290px"
              min-width="290px"
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                  v-model="fechaI"
                  prepend-icon="mdi-calendar-month"
                  v-on="on"
                  :cache-items="false"
                  placeholder="Fecha inicio"
                  autocomplete="off"
                  readonly
                />
              </template>

              <v-date-picker
                v-model="fechaI"
                no-title
                :cache-items="false"
                @input="menuI = false"
                :max="nowDate"
              >
              </v-date-picker>
            </v-menu>
          </v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <div class="subtitle-2"><b>Fecha fin </b></div>
            <v-menu
              ref="menuF"
              v-model="menuF"
              :close-on-content-click="false"
              :nudge-right="40"
              transition="scale-transition"
              offset-y
              :cache-items="false"
              max-width="290px"
              min-width="290px"
            >
              <template v-slot:activator="{ on }">
                <v-text-field
                  v-model="fechaF"
                  prepend-icon="mdi-calendar-month"
                  v-on="on"
                  :cache-items="false"
                  placeholder="Fecha inicio"
                  autocomplete="off"
                  readonly
                />
              </template>

              <v-date-picker
                v-model="fechaF"
                no-title
                :cache-items="false"
                @input="menuF = false"
                :max="nowDate"
              >
              </v-date-picker>
            </v-menu>
          </v-col>
          <v-col :cols="12" :sm="12" :md="2" :lg="2" :xl="2">
            <button class="btn" @click="buscar">Buscar</button>
          </v-col>

          <v-col :cols="12" :sm="12" :md="1" :lg="1" :xl="1" />
        </v-row>
        <br /><br /><br />
      </div>
    </v-card>
    <div v-if="mostrarTablaConsultaDescarga">
      <TablaConsultaDescargaComponent
        ref="tablaConsultaDescargaComponent"
        v-model="this.listaTabla"
      />
      <br /><br />

      <Button class="btn" @click="exportToExcel" style="margin: auto">
        Descargar Excel
      </Button>
      <br /><br />
    </div>
  </div>
</template>

<script>
import store from "@/store";
import FileSaver from "file-saver";
import moment from "moment";
import MultipleCheckboxNegocioComponent from "../componentes/MultipleCheckboxNegocioComponent.vue";
import ListaCecoComponente from "../componentes/ListaCecoComponente.vue";
import TablaConsultaDescargaComponent from "./TablaConsultaDescargaComponent.vue";
const axios = store.state.axiosApiLocal;
const hojaPlantilla = {
  descripcion: "ELEKTRA", //Nombre de la hoja
  contenido: {
    cabezeras: [
      {
        valor: "ceco",
        descripcion: "CECO",
      },
      {
        valor: "descripcionSucursal",
        descripcion: "Nombre Sucursal",
      },
      {
        valor: "negocio",
        descripcion: "Canal",
      },
      {
        valor: "descripcionFormato",
        descripcion: "formato",
      },
      {
        valor: "ultimaFechaCarga",
        descripcion: "Ultima fecha de carga",
      },
      {
        valor: "numProyectos",
        descripcion: "#proyectos",
      },
      {
        valor: "descripcionUltimoProyecto",
        descripcion: "Ultimo proyecto cargado",
      },
    ],
    registros: [],
  },
};
const excelPlantilla = {
  nombre: "Reporte de documentos", //Nombre del documento
  hojas: [],
};

export default {
  components: {
    MultipleCheckboxNegocioComponent,
    ListaCecoComponente,
    TablaConsultaDescargaComponent,
  },
  name: "consultar_descarga_documento_component",
  created() {},
  data() {
    return {
      nowDate: new Date().toISOString().slice(0, 10),
      contadorServicio: 0,
      mostrarAlertaBandera: false,
      mostrarTablaConsultaDescarga: false,
      mostrarMensajeAlerta: false,
      bandera: 0,
      buscado: false,
      disabled: false,
      menuI: false,
      fechaI: "",
      menuF: false,
      fechaF: "",
      negocios: [],
      listaDatosServicio: [],
      excel: {},
      value: {
        dataUnidadNegocio: {
          value: {
            idNegocio: "-1",
          },
        },
        dataCeco: {
          ceco: "",
          value: "",
        },
      },
    };
  },
  props: {},
  methods: {
    callbackCecoSeleccionado() {},
    borradoPorNivel() {},
    callbackChangeCheckBox(negocios) {
      if (negocios.length > 0) {
        this.disabled = true;
        this.negocios = negocios;
      } else {
        this.disabled = false;
        this.negocios = [];
      }
      console.log("revisar" + JSON.stringify(negocios));
    },
    validaFecha(fecha) {
      return moment(fecha, "DD-MM-YY", false).isValid();
    },
    buscar() {
      if (!this.buscado) {
        this.buscado = true;
        if (this.disabled) {
          this.validaConsultarPorNegocio();
        } else {
          this.validaConsultarPorCeco();
        }
      }
    },
    validaConsultarPorNegocio() {
      this.bandera = 0;
      if (this.negocios && this.negocios.length <= 0) {
        this.bandera = 1;
      } else if (!this.validaFecha(this.fechaI)) {
        this.bandera = 3;
      } else if (!this.validaFecha(this.fechaF)) {
        this.bandera = 3;
      }
      if (this.bandera == 0) {
        this.consultaServicioPorNegocio();
      } else {
        this.mostrarAlerta(true);
        this.buscado = false;
      }
    },
    validaConsultarPorCeco() {
      this.bandera = 0;
      if (!this.value.dataCeco.ceco) {
        this.bandera = 2;
      } else if (!this.validaFecha(this.fechaI)) {
        this.bandera = 3;
      } else if (!this.validaFecha(this.fechaF)) {
        this.bandera = 3;
      }
      if (this.bandera == 0) {
        this.consultaServicioPorCeco();
      } else {
        this.mostrarAlerta(true);
        this.buscado = false;
      }
    },
    consultaServicioPorCeco() {
      var body = {
        fechaInicio: moment(this.fechaI).format("DD/MM/YYYY"),
        fechaFin: moment(this.fechaF).format("DD/MM/YYYY"),
        idNegocio: null,
        idCeco: this.value.dataCeco.ceco,
      };

      this.consumeServicio(body);
    },
    consultaServicioPorNegocio() {
      this.contadorServicio = 0;
      this.negocios.map((nego) => {
        var body = {
          fechaInicio: moment(this.fechaI).format("DD/MM/YYYY"),
          fechaFin: moment(this.fechaF).format("DD/MM/YYYY"),
          idNegocio: "" + nego.idNegocio,
          idCeco: null,
        };
        this.consumeServicio(body);
      });
      if (this.negocios.length < 1) {
        this.buscado = false;
      }
    },
    consumeServicio(body) {
      this.listaDatosServicio = [];

      axios
        .post("/reportes-layout/v1/excel", body)
        .then((response) => {
          let data = response.data.resultado;
          this.llamadoCallback(data);
        })
        .catch((err) => {
          if (err.response) {
            this.llamadoCallback(null);
          }
        });
    },

    llamadoCallback(response) {
      this.contadorServicio = this.contadorServicio + 1;
      if (response) {
        this.listaDatosServicio = this.listaDatosServicio.concat(response);
      }
      if (this.contadorServicio < this.negocios.length) {
        //console.log(JSON.stringify("OK" + JSON.stringify(response)));
      } else {
        // console.log(JSON.stringify("OK" + JSON.stringify(response)));
        console.log("Termino de Consultar servicio");
        this.parsearDatosExcel();
        this.parsearDatosTabla();
        this.cargarTabla();
      }
    },
    parsearDatosTabla() {
      this.listaTabla = [];
      if (this.listaDatosServicio && this.listaDatosServicio.length > 0) {
        this.listaDatosServicio.map((item) => {
          if (this.listaTabla && this.listaTabla.length > 0) {
            var prueba = this.listaTabla.find(
              (i) =>
                i.idFormato == item.idFormato &&
                i.idProyecto == item.idProyecto &&
                i.idFormato == item.idFormato &&
                i.idCeco == item.idCeco
            );
            if (!prueba) {
              this.listaTabla = this.listaTabla.concat(item);
            }
          } else {
            this.listaTabla = this.listaTabla.concat(item);
          }
        });
        console.log("Tabla==>" + JSON.stringify(this.listaTabla));
      }
    },
    cargarTabla() {
      if (this.$refs.tablaConsultaDescargaComponent) {
        this.$refs.tablaConsultaDescargaComponent.cargaDatos(this.listaTabla);
      } else {
        this.mostrarTablaConsultaDescarga = true;
      }

      this.buscado = false;
    },

    parsearDatosExcel() {
      if (this.listaDatosServicio && this.listaDatosServicio.length > 0) {
        this.excel = JSON.parse(JSON.stringify(excelPlantilla));
        var negocioCargado = [];
        this.listaDatosServicio.map((items) => {
          if (!negocioCargado.find((x) => x == items.idNegocio)) {
            var hojasPlantillaNegocio = JSON.parse(
              JSON.stringify(hojaPlantilla)
            );
            negocioCargado = negocioCargado.concat(items.idNegocio);

            var camposCabecera = this.obtieneCamposCabecera(items.idNegocio);
            hojasPlantillaNegocio.contenido.cabezeras =
              hojasPlantillaNegocio.contenido.cabezeras.concat(camposCabecera);

            var camposCuerpo = this.obtieneCamposCuerpo(items.idNegocio);
            hojasPlantillaNegocio.contenido.registros =
              hojasPlantillaNegocio.contenido.registros.concat(camposCuerpo);

            hojasPlantillaNegocio.descripcion = items.nombreNegocio;

            this.excel.hojas = this.excel.hojas.concat(hojasPlantillaNegocio);
          }
        });

        console.log("DatosExcel==> " + JSON.stringify(this.excel));
      }
    },
    obtieneCamposCuerpo(negocioTemp) {
      var retorno = [];
      var cecos = [];
      this.listaDatosServicio.map((item) => {
        var existeCeco = cecos.find((x) => x == item.idCeco);
        if (!existeCeco && negocioTemp == item.idNegocio) {
          var objetoCuerpo = {
            ceco: item.idCeco,
            descripcionSucursal: item.nombreCeco ? item.nombreCeco : "",
            negocio: item.nombreNegocio,
            descripcionFormato: item.nombreFormato,
            ultimaFechaCarga: item.Fecha ? item.Fecha : "",
            numProyectos: item.conteoProyecto,
            descripcionUltimoProyecto: item.nombreProyecto,
          };
          cecos = cecos.concat(item.idCeco);
          var listaDetalles = this.listaDatosServicio.filter(
            (x) => x.idCeco == item.idCeco
          );
          listaDetalles.map((itemListaDetalle) => {
            var propiedad = "objetoCuerpo.zona" + itemListaDetalle.idZona;
            var valor = itemListaDetalle.valor + "";
            eval(propiedad + "='" + valor + "'");
          });
          retorno = retorno.concat(objetoCuerpo);
        }
      });
      return retorno;
    },
    obtieneCamposCabecera(negocioTemp) {
      var retorno = [];
      this.listaDatosServicio.map((item) => {
        if (
          item.idNegocio == negocioTemp &&
          !retorno.find((x) => x.descripcion == item.nombreZona)
        ) {
          var objetoCabecera = {
            valor: "zona" + item.idZona,
            descripcion: item.nombreZona,
          };

          retorno = retorno.concat(objetoCabecera);
        }
      });
      return retorno;
    },
    exportToExcel() {
      if (this.listaDatosServicio && this.listaDatosServicio.length > 0) {
        var data = this.excel;
        axios({
          method: "post",
          url: "/utilerias/archivos/convertir/json/excel/plantilla",
          responseType: "blob",
          data: data,
        })
          .then((response) => {
            if (response.headers["content-type"] !== "application/json") {
              FileSaver.saveAs(response.data, response.headers["file-name"]);
            }
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },
    mostrarAlerta(mostrar) {
      this.mostrarAlertaBandera = mostrar;
    },
  },
};
</script>

<style lang="scss" scoped></style>